import java.util.*;

public class Node<T> {
 private Node<T> left;
 private T value;
 private Node<T> right;
 
 public Node(Node<T> left, T value, Node<T> right){
  this.left = left;
  this.value = value;
  this.right = right;
 }
 public T getValue() {return this.value;}
 public Node<T> getLeft() {return this.left;}
 public Node<T> getRight() {return this.right;}
 public int size() {
   int sizeLeft = 0;
   int sizeRight = 0;
   
   if (this.left != null) {sizeLeft = this.left.size();}
   if (this.right != null) {sizeRight = this.right.size();}
   return 1+ sizeLeft + sizeRight;
 }
 public int depth() {
    int depthLeft = -1;
    int depthRight = -1;
    if (this.left != null) {depthLeft = this.left.depth();}   
    if (this.right != null) {depthRight = this.right.depth();}
    return 1+Math.max(depthLeft,depthRight);
 } 
}
